package com.zipcodewilmington.gildedrose;

import org.junit.Assert;
import org.junit.Test;

public class InventoryTest {
    Item agedBrie = new Item("Aged Brie", 7,40);
    Item backStage = new Item("Backstage passes to a TAFKAL80ETC concert", 10,20);
    Item sulfuras = new Item("Sulfuras, Hand of Ragnaros", 4,15);
    Item[] item = {agedBrie, backStage, sulfuras};

    Inventory inv = new Inventory(item);

    @Test
    public void updateQuantityTest(){
        inv.updateQuality();
        int actual = agedBrie.getQuality();
        int expected = 41;
        Assert.assertEquals(expected,actual);
    }

    @Test
    public void updateQuantityTest2(){
        inv.updateQuality();
        int actual = backStage.getQuality();
        int expected = 22;
        Assert.assertEquals(expected,actual);
    }

    @Test
    public void updateQuantityTest3(){
        backStage.setSellIn(4);
        inv.updateQuality();
        int actual = backStage.getQuality();
        int expected = 23;
        Assert.assertEquals(expected,actual);
    }

    @Test
    public void updateQuantityTest4(){
        inv.updateQuality();
        int actual = sulfuras.getQuality();
        int expected = 15;
        Assert.assertEquals(expected,actual);
    }

    @Test
    public void updateQuantityTest5(){
        inv.updateQuality();
        int actual = backStage.getSellIn();
        int expected = 9;
        Assert.assertEquals(expected,actual);
    }

    @Test
    public void updateQuantityTest6(){
        inv.updateQuality();
        int actual = agedBrie.getSellIn();
        int expected = 6;
        Assert.assertEquals(expected,actual);
    }

    @Test
    public void updateQuantityTest7(){
        agedBrie.setSellIn(-1);
        inv.updateQuality();
        int actual = agedBrie.getQuality();
        int expected = 42;
        Assert.assertEquals(expected,actual);
    }

    @Test
    public void updateQuantityTest8(){
        backStage.setSellIn(-1);
        inv.updateQuality();
        int actual = backStage.getQuality();
        int expected = 0;
        Assert.assertEquals(expected,actual);
    }

    @Test
    public void updateQuantityTest9(){
        sulfuras.setSellIn(-1);
        inv.updateQuality();
        int actual = sulfuras.getQuality();
        int expected = 15;
        Assert.assertEquals(expected,actual);
    }

    @Test
    public void updateQuantityTest10(){
        sulfuras.setName("Aged Brie");
        inv.updateQuality();
        int actual = sulfuras.getQuality();
        int expected = 16;
        Assert.assertEquals(expected,actual);
    }
}

